Index: cpukit/libdl/rtl-unresolved.c
===================================================================
--- cpukit/libdl/rtl-unresolved.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-unresolved.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -28,4 +28,5 @@
 #include <rtems/rtl/rtl-unresolved.h>
 #include <rtems/rtl/rtl-trace.h>
+#include "rtl-trampoline.h"
 
 static rtems_rtl_unresolv_block*
@@ -70,5 +71,5 @@
 static int
 rtems_rtl_unresolved_rec_index (rtems_rtl_unresolv_block* block,
-                                rtems_rtl_unresolv_rec* rec)
+                                rtems_rtl_unresolv_rec*   rec)
 {
   return rec - &block->rec[0];
@@ -102,4 +103,5 @@
 
     case rtems_rtl_unresolved_reloc:
+    case rtems_rtl_trampoline_reloc:
       ++rec;
       break;
@@ -402,4 +404,23 @@
   bytes = count * sizeof (rtems_rtl_unresolv_rec);
   memset (&block->rec[block->recs], 0, bytes);
+}
+
+static rtems_chain_node*
+rtems_rtl_unresolved_delete_block_if_empty (rtems_chain_control*      blocks,
+                                            rtems_rtl_unresolv_block* block)
+{
+  rtems_chain_node* node = &block->link;
+  rtems_chain_node* next_node = rtems_chain_next (node);
+  /*
+   * Always leave a single block allocated. Eases possible heap fragmentation.
+   */
+  if (block->recs == 0 && !rtems_chain_has_only_one_node (blocks))
+  {
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_UNRESOLVED))
+      printf ("rtl: unresolv: block-del %p\n", block);
+    rtems_chain_extract (node);
+    rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_EXTERNAL, block);
+  }
+  return next_node;
 }
 
@@ -457,17 +478,6 @@
       }
 
-      if (block->recs == 0)
-      {
-        rtems_chain_node* next_node = rtems_chain_next (node);
-        if (rtems_rtl_trace (RTEMS_RTL_TRACE_UNRESOLVED))
-          printf ("rtl: unresolv: block-del %p\n", block);
-        rtems_chain_extract (node);
-        rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_EXTERNAL, block);
-        node = next_node;
-      }
-      else
-      {
-        node = rtems_chain_next (node);
-      }
+      node = rtems_rtl_unresolved_delete_block_if_empty (&unresolved->blocks,
+                                                         block);
     }
   }
@@ -481,5 +491,5 @@
   unresolved->block_recs = block_recs;
   rtems_chain_initialize_empty (&unresolved->blocks);
-  return true;
+  return rtems_rtl_unresolved_block_alloc (unresolved);
 }
 
@@ -633,11 +643,11 @@
   /*
    * The resolving process is two separate stages, The first stage is to
-   * iterate over the unresolved symbols search the global symbol table. If a
-   * symbol is found iterate over the unresolved relocation records for the
+   * iterate over the unresolved symbols searching the global symbol table. If
+   * a symbol is found iterate over the unresolved relocation records for the
    * symbol fixing up the relocations. The second stage is to search the
-   * archives for symbols we have not been search before and if a symbol if
-   * found in an archve loaded the object file. Loading an object file stops
-   * the search of the archives for symbols and stage one is performed
-   * again. The process repeats until no more symbols are resolved.
+   * archives for symbols we have not searched before and if a symbol is found
+   * in an archve load the object file. Loading an object file stops the
+   * search of the archives for symbols and stage one is performed again. The
+   * process repeats until no more symbols are resolved or there is an error.
    */
   while (resolving)
@@ -666,14 +676,83 @@
 
 bool
-rtems_rtl_unresolved_remove (rtems_rtl_obj*        obj,
-                             const char*           name,
-                             const uint16_t        sect,
-                             const rtems_rtl_word* rel)
-{
-  rtems_rtl_unresolved* unresolved;
+rtems_rtl_trampoline_add (rtems_rtl_obj*        obj,
+                          const uint16_t        flags,
+                          const uint16_t        sect,
+                          const rtems_rtl_word  symvalue,
+                          const rtems_rtl_word* rel)
+{
+  rtems_rtl_unresolved*     unresolved;
+  rtems_rtl_unresolv_block* block;
+  rtems_rtl_unresolv_rec*   rec;
+
+  if (rtems_rtl_trace (RTEMS_RTL_TRACE_UNRESOLVED))
+    printf ("rtl: tramp: add: %s sect:%d flags:%04x\n",
+            rtems_rtl_obj_oname (obj), sect, flags);
+
   unresolved = rtems_rtl_unresolved_unprotected ();
-  if (unresolved == NULL)
+  if (!unresolved)
     return false;
+
+  block = rtems_rtl_unresolved_alloc_recs (unresolved, 1);
+  if (block == NULL)
+  {
+    block = rtems_rtl_unresolved_block_alloc (unresolved);
+    if (!block)
+      return false;
+  }
+
+  rec = rtems_rtl_unresolved_rec_first_free (block);
+  rec->type = rtems_rtl_trampoline_reloc;
+  rec->rec.tramp.obj = obj;
+  rec->rec.tramp.flags = flags;
+  rec->rec.tramp.sect = sect;
+  rec->rec.tramp.symvalue = symvalue;
+  rec->rec.tramp.rel[0] = rel[0];
+  rec->rec.tramp.rel[1] = rel[1];
+  rec->rec.tramp.rel[2] = rel[2];
+
+  ++block->recs;
+
   return true;
+}
+
+void
+rtems_rtl_trampoline_remove (rtems_rtl_obj* obj)
+{
+  rtems_rtl_unresolved* unresolved = rtems_rtl_unresolved_unprotected ();
+  if (unresolved)
+  {
+    /*
+     * Iterate over the blocks clearing any trampoline records.
+     */
+    rtems_chain_node* node = rtems_chain_first (&unresolved->blocks);
+    while (!rtems_chain_is_tail (&unresolved->blocks, node))
+    {
+      rtems_rtl_unresolv_block* block = (rtems_rtl_unresolv_block*) node;
+      rtems_rtl_unresolv_rec*   rec = rtems_rtl_unresolved_rec_first (block);
+
+      /*
+       * Search the table for a trampoline record and if found clean the
+       * record moving the remaining records down the block.
+       */
+      while (!rtems_rtl_unresolved_rec_is_last (block, rec))
+      {
+        bool next_rec = true;
+
+        if (rec->type == rtems_rtl_trampoline_reloc && rec->rec.tramp.obj == obj)
+        {
+            rtems_rtl_unresolved_clean_block (block, rec, 1,
+                                              unresolved->block_recs);
+            next_rec = false;
+        }
+
+        if (next_rec)
+          rec = rtems_rtl_unresolved_rec_next (rec);
+      }
+
+      node = rtems_rtl_unresolved_delete_block_if_empty (&unresolved->blocks,
+                                                         block);
+    }
+  }
 }
 
@@ -709,6 +788,8 @@
     break;
   case rtems_rtl_unresolved_reloc:
+  case rtems_rtl_trampoline_reloc:
     if (dd->show_relocs)
-      printf (" %3zu: 2: reloc: obj:%s name:%2d: sect:%d\n",
+      printf (" %3zu: 2:reloc%c: obj:%s name:%2d: sect:%d\n",
+              rec->type == rtems_rtl_unresolved_reloc ? 'R' : 'T',
               dd->rec,
               rec->rec.reloc.obj == NULL ? "resolved" : rec->rec.reloc.obj->oname,
Index: cpukit/libdl/rtl.c
===================================================================
--- cpukit/libdl/rtl.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -478,19 +478,22 @@
 rtems_rtl_find_obj_with_symbol (const rtems_rtl_obj_sym* sym)
 {
-  rtems_chain_node* node = rtems_chain_first (&rtl->objects);
-  while (!rtems_chain_is_tail (&rtl->objects, node))
-  {
-    rtems_rtl_obj* obj = (rtems_rtl_obj*) node;
-    if (rtems_rtl_obj_has_symbol (obj, sym))
-      return obj;
-    node = rtems_chain_next (node);
-  }
-  node = rtems_chain_first (&rtl->pending);
-  while (!rtems_chain_is_tail (&rtl->pending, node))
-  {
-    rtems_rtl_obj* obj = (rtems_rtl_obj*) node;
-    if (rtems_rtl_obj_has_symbol (obj, sym))
-      return obj;
-    node = rtems_chain_next (node);
+  if (sym != NULL)
+  {
+    rtems_chain_node* node = rtems_chain_first (&rtl->objects);
+    while (!rtems_chain_is_tail (&rtl->objects, node))
+    {
+      rtems_rtl_obj* obj = (rtems_rtl_obj*) node;
+      if (rtems_rtl_obj_has_symbol (obj, sym))
+        return obj;
+      node = rtems_chain_next (node);
+    }
+    node = rtems_chain_first (&rtl->pending);
+    while (!rtems_chain_is_tail (&rtl->pending, node))
+    {
+      rtems_rtl_obj* obj = (rtems_rtl_obj*) node;
+      if (rtems_rtl_obj_has_symbol (obj, sym))
+        return obj;
+      node = rtems_chain_next (node);
+    }
   }
   return NULL;
Index: testsuites/libtests/dl08/init.c
===================================================================
--- testsuites/libtests/dl08/init.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ testsuites/libtests/dl08/init.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -57,5 +57,5 @@
   }
 
-  for (i = 0; i < 100; ++i)
+  for (i = 0; i < 4; ++i)
   {
     printf ("--------------------------------------------------\n");
Index: testsuites/libtests/dl09/dl-o1.c
===================================================================
--- testsuites/libtests/dl09/dl-o1.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ testsuites/libtests/dl09/dl-o1.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -56,4 +56,5 @@
   printf (DL_NAME ":       dl01_const2: %4zu: %p: %f\n",   PAINT_VAR (dl01_const2));
   printf (DL_NAME ":        dl01_func1: %4zu: %p\n",       sizeof(dl01_func1), &dl01_func1);
+  printf (DL_NAME ":     rtems_main_o2:       %p\n",       &rtems_main_o2);
 
   rtems_main_o2 ();
Index: testsuites/libtests/dl09/init.c
===================================================================
--- testsuites/libtests/dl09/init.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ testsuites/libtests/dl09/init.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -57,5 +57,5 @@
   }
 
-  for (i = 0; i < 100; ++i)
+  for (i = 0; i < 4; ++i)
   {
     printf ("--------------------------------------------------\n");
